/*******************************************************************************
 *  Copyright 2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;


import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_DetectorTypes;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_DetectorTypes;


/**
 * This class represents DetectorTypes - CID10030
 */
public class DetectorTypes_CID10030 
{
	
	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;

	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;

	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;

	/**
	 * Instantiates a new DetectorTypes_CID10030 Template 
	 */
	public DetectorTypes_CID10030()
	{

	}

	/**
	 * Retrieves the value for Code Meaning.
	 * @return String value for Code Meaning.
	 */
	public String getCodeMeaning()
	{
		return strCodeMeaning;
	}

	/**
	 * Retrieves the value for Code Value.
	 * @return String value for Code Value.
	 */
	public String getCodeValue() 
	{
		return strCodeValue;
	}

	/**
	 * Retrieves the value for Coding Scheme Designator.
	 * @return String value for Coding Scheme Designator.
	 */
	public String getCodingSchemeDesignator() 
	{
		return strCodingSchemeDesignator;
	}

	/**
	 * Sets the Code Value according to Code Meaning.
	 * @param enumDetectorTypes Object of EnumCM_DetectorTypes represents Code Meaning.
	 */
	private void setCodeValue(EnumCM_DetectorTypes enumDetectorTypes)
	{
		switch(enumDetectorTypes)
		{
		case DIRECT_DETECTOR: this.strCodeValue =EnumCV_DetectorTypes.DIRECT_DETECTOR_113948.getValue(); break;
		case INDIRECT_DETECTOR: this.strCodeValue =EnumCV_DetectorTypes.INDIRECT_DETECTOR_113949.getValue(); break;
		case STORAGE_DETECTOR: this.strCodeValue =EnumCV_DetectorTypes.STORAGE_DETECTOR_113950.getValue(); break;
		case FILM: this.strCodeValue =EnumCV_DetectorTypes.FILM_113951.getValue(); break;
		}
	}

	/**
	 * Sets the value for DetectorTypes
	 * @param enumDetectorTypes Object of EnumCM_DetectorTypes.
	 */
	public void setDetectorTypes(EnumCM_DetectorTypes enumDetectorTypes)
	{
		/**
		 * Retrieves the value for CodingSchemeDesignator, CodingSchemeVersion and Code Meaning and 
		 * sets the Code Value according to Code Meaning.
		 */
		this.strCodeMeaning = enumDetectorTypes.getValue();
		this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.DCM.getValue();
		
		/**
		 * set code Value
		 */
		setCodeValue(enumDetectorTypes);
	}
}
